﻿$infile = [System.IO.StreamReader] "C:\Users\bryorkj\Desktop\DNSlogDetail.txt"
$outfile = [System.IO.StreamWriter] "C:\Users\bryorkj\Desktop\dns-detail-out.txt"
$Regex = '(\d*/\d*/\d*\s+\d*:\d*:\d*\s+AM|PM).+Snd\s+(10\.48\.[0-7]\.\d+).+\s+A\s+(\(.*)'
$DataRegex = '\s+(Name|DATA)\s+(.+$)'
$dateTimeRegex = '\d*/\d*/\d*\s+\d*:\d*:\d*\s+AM|PM'
$start = Get-Date
$ANSWER_isset = $SndA_isset = $false
while (($line = $infile.ReadLine()) -ne $null) {
    if ($line -match $dateTimeRegex) {$ANSWER_isset = $SndA_isset = $false}
    if ($line -match $Regex) {
       $SndA_isset = $true
    }
    else {if ($line -like "*ANSWER*") {$ANSWER_isset = $true}
          else {
                if ($ANSWER_isset -and $SndA_isset -and $line -match $DataRegex) {
                  if ($Matches[1] -eq "Name") {
                    $Name = $Matches[2] -replace '"|\[.{1,5}\]', ""
                    $Name = ($Name -replace "\(\d+\)", ".").Trim(".")
                  }
                  else {
                    $Data = $Matches[2] -replace '"|\[.{1,5}\]', ""
                    $Data = ($Data -replace "\(\d+\)", ".").Trim(".")
                    $outfile.WriteLine([string]$Name +","+ $Data +","+ $Type)
                  }
                }
                else {if ($line -match '\s+TYPE\s+(.*)\s+\(') {
                        $Type = $matches[1]
                      }
                }        
          }  
          }

    }
$infile.Dispose()
$outfile.Close()




